
//  Etsi.java  Copyright (c) 2006 Kari Laitinen

//  http://www.naturalprogramming.com

//  2006-03-06  Tiedosto luotu.
//  2006-03-06  Viimeisin muutos.

//  Paras tapa tmn ohjelman suorittamiseksi on ajaa tt
//  komentorivi-ikkunassa jossa ohjelmalle voidaan sytt
//  komentoriviparametreja. Voi olla vaikeaa, ellei jopa mahdotonta,
//  antaa komentoriviparametreja silloin kun sit ajetaan
//  modernilla ohjelmakehitystykalulla kuten JCreatorilla tai
//  Eclipsell.

//  Tm ohjelma osaa kuitenkin pyyt kyttjlt tarvittavat
//  tiedot jos niit ei annettu komentorivilt.

import java.io.* ;
import java.util.* ;

class Etsi
{
   static void etsi_stringia_tiedostosta( String  tiedoston_nimi_kutsujalta,
                                          String  etsittava_stringi )
   {
      try
      {
         BufferedReader luettava_tiedosto  =
             new BufferedReader( new FileReader( tiedoston_nimi_kutsujalta ) ) ;

         System.out.print( "\n Etsitaan stringia ... \""
                        +  etsittava_stringi  + "\"\n" ) ;

         int  rivilaskuri  =  0 ;
         boolean  tiedoston_loppu_kohdattu  =  false ;

         while ( tiedoston_loppu_kohdattu  ==  false )
         {
            String  tekstirivi_tiedostosta   =  luettava_tiedosto.readLine() ;

            if ( tekstirivi_tiedostosta  ==  null )
            {
               tiedoston_loppu_kohdattu  =  true ;
            }
            else
            {
               rivilaskuri  ++ ;

               if ( tekstirivi_tiedostosta.contains( etsittava_stringi ) )
               {
                  System.out.print( "\n \"" +  etsittava_stringi
                                  + "\" loytyi rivilta "  +  rivilaskuri ) ;
               }
            }
         }

         luettava_tiedosto.close() ;
      }
      catch ( FileNotFoundException vangittu_tiedostoa_ei_loydy_poikkeus )
      {
         System.out.print( "\n \"" + tiedoston_nimi_kutsujalta + "\" ei aukea");
      }
      catch ( IOException vangittu_io_poikkeus )
      {
         System.out.print( "\n\n  Virhe tiedostojen kasittelyssa.  \n" ) ;
      }
   }


   public static void main( String[] komentoriviparametrit )
   {
      Scanner nappaimisto = new Scanner( System.in ) ;

      if ( komentoriviparametrit.length  ==  2 )
      {
         etsi_stringia_tiedostosta ( komentoriviparametrit[ 0 ],
                                     komentoriviparametrit[ 1 ] ) ;
      }
      else
      {
         System.out.print( "\n Tama ohjelma etsii annettua stringia "
                         + "\n tekstitiedostosta. Anna tiedoston nimi :  " ) ;

         String  kayttajan_antama_tiedoston_nimi  =  nappaimisto.nextLine() ;

         System.out.print( "\n Anna etsittava stringi: " ) ;

         String  etsittava_stringi    =  nappaimisto.nextLine() ;

         etsi_stringia_tiedostosta( kayttajan_antama_tiedoston_nimi,
                                    etsittava_stringi ) ;
      }
   }
}


